<?php
/**
 * Действия при изменении статуса заказа
 *
 * @version 5.0.1
 *
 */


/*------------Действие когда статус заказа выполнен - начисление баллов------------*/
$val = get_option('bonus_option_name');
$order_status = $val['add_points_order_status'] ?? 'completed';

add_action('woocommerce_order_status_'.$order_status, 'add_computy_points', 10, 1);
function add_computy_points($order_id)
{

/*вызов информации о заказе*/
$order = wc_get_order($order_id);


/*узнаем id покупателя*/
$customer_user = $order->get_customer_id();

 if($customer_user!=0){ /*Проверяем зарегистрирован ли клиент*/

/*сумма покупок данного заказа*/
$total = (float)$order->get_total();

/*---------Находим товары и категории, которые надо исключить---------*/

if ((new BfwRoles)->is_pro()) {
    $val = get_option('bonus_option_name');
    /*находим метод оплаты, который надо исключить из системы*/
 $pm = $order->get_payment_method(); //выводит id метода оплаты!!!
    if (!empty($val['exclude-payment-method'])){
        if (in_array($pm, $val['exclude-payment-method'])){
            return false;
        }
    }
    /*находим метод оплаты, который надо исключить из системы*/
$order_items = $order->get_items();

    if (!empty($val['cashback-for-shipping'])){
        /*убираем сумму доставки с кешбэка*/
        /*TODO исправить работу плагина доставки СДЭК, Почта РФ, Озон логистик*/

        $shipping_total = $order->get_shipping_total();
        $total = $total - $shipping_total;
    }



$addcashbckexclude = $val['addkeshback-exclude'] ?? 0;

if ($addcashbckexclude != '1') {

$categoriexs = $val['exclude-category-cashback'] ?? 'not';

$exclude_tovar = $val['exclude-tovar-cashback'];
$tovars = explode(",", $exclude_tovar);


foreach ($order_items as $item_id => $item) {

$product_id = $item->get_product_id();
$item_data = $item->get_data();



if (in_array($product_id, $tovars)) {
if (!has_term($categoriexs, 'product_cat', $product_id)) {
$sum_exclud_tov = $item_data['subtotal'];
$total = $total - $sum_exclud_tov;
}
}

if (has_term($categoriexs, 'product_cat', $product_id)) {
$sum_exclud_cat = $item_data['subtotal'];
$total = $total - $sum_exclud_cat;
}
}
}


}/*pro*/
/*---------Находим товары и категории, которые надо исключить---------*/

    /*узнаем баллы клиента*/
$computy_point_old = (new BfwPoints)->getPoints($customer_user);

   if((new BfwRoles)->is_invalve($customer_user)){/*Если участвует в бонусной системе*/

        /*минимальная сумма заказа*/
        if ((new BfwRoles)->is_pro()){
            if(isset($val['minimal-amount'])){
                if($total<$val['minimal-amount']){
                    if(!empty($val['minimal-amount-cashback'])){
                       return false;
                    }
                }}
        }
        /*минимальная сумма заказа*/


        (new BfwRoles)->updateRole($customer_user); //обновляем роль
        $percent = (new BfwRoles)->getRole($customer_user)['percent'];//находим процент


        /*-----добавляем бонусные баллы на счет клиента-----*/

        /*узнаем баллы, которые решил списать клиент*/
        $computy_point_fast = (new BfwPoints)->getFastPoints($customer_user);

        $computy_point_new = ($total - $computy_point_fast) * ($percent / 100);
        $computy_point_new = (new BfwPoints())->roundPoints($computy_point_new);
        $cout_point = $computy_point_old +  $computy_point_new;
        $cout_point = (new BfwPoints())->roundPoints($cout_point); //округляем если надо


       if ($computy_point_fast > 0) {
            $cout_point = $cout_point - $computy_point_fast;
        }


       $fee_total=0;

       if (!empty($val['fee-or-coupon'])) {
           /* если бонусы с помощью купонов  */
           foreach( $order->get_coupon_codes() as $coupon_code  ) {
               $coupon = new WC_Coupon($coupon_code);
               $get_code = $coupon->get_code();
               $cart_discount =  mb_strtolower($val['bonus-points-on-cart']);
               if(strtolower($get_code)=== strtolower($cart_discount)){
                   $fee_total = $order->get_discount_total();
               }
           }

       }else{
           /*если бонусы с помощью комиссий*/
           foreach( $order->get_items('fee') as $item_id => $item_fee ){
               // The fee name
               $val = get_option( 'bonus_option_name' );
               if( $item_fee->get_name()== $val['bonus-points-on-cart']){
                   $fee_total = $item_fee->get_total();
               }
           }
       }

       $fee_total = absint($fee_total);/*модуль*/


       if(isset($val['yous_balls_no_cashback']) AND $fee_total > 0){
           //если используются баллы - кешбэк не дается.
              }else{
           /*запись в историю*/
                  $pricina = __('Points accrual', 'bonus-for-woo');
                  (new BfwHistory)->add_history($customer_user,'+',$computy_point_new,$order_id,$pricina);

                  /*email*/
                  $val = get_option( 'bonus_option_name' );
                  $text_email = $val['email-when-order-change-text'] ?? '';
                  /*шаблонизатор письма*/
                  $title_email = $val['email-when-order-change-title'] ?? __('Points accrual', 'bonus-for-woo');
                  $user = get_userdata($customer_user);
                  $get_referral = get_user_meta($customer_user, 'bfw_points_referral', true );
                  $text_email_array = array('[user]'=>$user->display_name,'[order]'=>$order_id,'[points]'=>$computy_point_new,'[total]'=>$cout_point, '[referral-link]'=> esc_url(site_url().'?bfwkey='. $get_referral));
                  $message_email = (new BfwEmail)->template($text_email,$text_email_array);
                  /*шаблонизатор письма*/

                  if(!empty($val['email-when-order-change'])){
                      (new BfwEmail)->getMail($customer_user, '', $title_email, $message_email);
                  }
                  /*email*/

                  (new BfwPoints)->updatePoints($customer_user,$cout_point);//добавляем баллы клиенту

   }

        (new BfwPoints)->updateFastPoints($customer_user,0);//очищаем добавленную скидку


        $referalwork = isset( $val['referal-system'] ) ? intval( $val['referal-system'] ) : 0;
        /*если включена реферальная система*/
        if($referalwork) {

            //узнать если у пользователя инвайт
            //bog<-invaite<-client
            $get_referral_invite = get_user_meta($customer_user, 'bfw_points_referral_invite', true);
            $get_referral_invite = (int)$get_referral_invite;
            if ($get_referral_invite != 0) {

                $percent_for_referal = $val['referal-cashback'];
                $referal_point_new = ($total - $computy_point_fast) * ($percent_for_referal / 100);
                $referal_point_new = (new BfwPoints())->roundPoints($referal_point_new);
                /*узнаем баллы реферала*/
                $old_point_referal = (new BfwPoints)->getPoints($get_referral_invite);

                $referal_points = $old_point_referal + $referal_point_new;
                if((int)$referal_points!=0){
                $pricinaref = __('Points for referral', 'bonus-for-woo');

                /*шаблонизатор письма*/
                $text_email = $val['email-when-order-change-referal-text'] ?? '';

                $title_email = $val['email-when-order-change-referal-title'] ?? __('Points accrual', 'bonus-for-woo');
                $user = get_userdata($get_referral_invite);
                $get_referral = get_user_meta($get_referral_invite, 'bfw_points_referral', true);
                $text_email_array = array(
                    '[referral-link]' => esc_url(site_url() . '?bfwkey=' . $get_referral),
                    '[user]' => $user->display_name,
                    '[cause]' => $pricinaref,
                    '[points]' => $referal_point_new,
                    '[total]' => $referal_points
                );
                $message_email = (new BfwEmail)->template($text_email, $text_email_array);
                /*шаблонизатор письма*/

                //если галочка стоит только первый заказ, то проверка является ли заказ первым
                 if (!empty($val['first-order-referal'])) {
                    //проверка является ли заказ первым
                    $numorders = wc_get_customer_order_count($customer_user);
                    if ($numorders == 1) {
                        (new BfwHistory)->add_history($get_referral_invite, '+', $referal_point_new, '0', $pricinaref);
                        $val = get_option('bonus_option_name');
                        if (!empty($val['email-when-order-change'])) {
                            (new BfwEmail)->getMail($get_referral_invite, '', $title_email, $message_email);
                        }
                        /*email*/
                        (new BfwPoints)->updatePoints($get_referral_invite, $referal_points); //добавляем баллы инвайту
                    }
                } else {

                    (new BfwHistory)->add_history($get_referral_invite, '+', $referal_point_new, '0', $pricinaref);
                    /*email*/
                    $val = get_option('bonus_option_name');
                    if (!empty($val['email-when-order-change'])) {
                        (new BfwEmail)->getMail($get_referral_invite, '', $title_email, $message_email);
                    }
                    /*начислить баллы инвайту*/
                    (new BfwPoints)->updatePoints($get_referral_invite, $referal_points); //добавляем баллы инвайту

                }
            }

                //тут будем начислять от инвайта второго уровня
                if (!empty($val['level-two-referral'])) {
                    $get_referral_invite_two_level = get_user_meta($get_referral_invite, 'bfw_points_referral_invite', true);
                    $get_referral_invite_two_level = (int)$get_referral_invite_two_level;
                    if($get_referral_invite_two_level != 0){
                        $percent_for_referal_two_level = $val['referal-cashback-two-level'];
                        $referal_two_point_new = ($total - $computy_point_fast) * ($percent_for_referal_two_level / 100);
                        $referal_two_point_new = (new BfwPoints())->roundPoints($referal_two_point_new);
                        /*узнаем баллы рефералов*/
                        $old_point_two_referal = (new BfwPoints)->getPoints($get_referral_invite_two_level);

                        $two_referal_points = $old_point_two_referal + $referal_two_point_new;
                        if((int)$two_referal_points!=0){
                            $pricinaref = __('Points for referral', 'bonus-for-woo');

                            /*шаблонизатор письма*/
                            $text_email = $val['email-when-order-change-referal-text'] ?? '';

                            $title_email = $val['email-when-order-change-referal-title'] ?? __('Points accrual', 'bonus-for-woo');
                            $user = get_userdata($get_referral_invite_two_level);
                            $get_referral = get_user_meta($get_referral_invite_two_level, 'bfw_points_referral', true);
                            $text_email_array = array(
                                '[referral-link]' => esc_url(site_url() . '?bfwkey=' . $get_referral_invite),
                                '[user]' => $user->display_name,
                                '[cause]' => $pricinaref,
                                '[points]' => $referal_two_point_new,
                                '[total]' => $two_referal_points
                            );
                            $message_email = (new BfwEmail)->template($text_email, $text_email_array);
                            /*шаблонизатор письма*/

                            //если галочка стоит только первый заказ, то проверка является ли заказ первым
                            if (!empty($val['first-order-referal'])) {
                                //проверка является ли заказ первым
                                $numorders = wc_get_customer_order_count($customer_user);
                                if ($numorders == 1) {
                                    (new BfwHistory)->add_history($get_referral_invite_two_level, '+', $referal_two_point_new, '0', $pricinaref);
                                    $val = get_option('bonus_option_name');
                                    if (!empty($val['email-when-order-change'])) {
                                        (new BfwEmail)->getMail($get_referral_invite_two_level, '', $title_email, $message_email);
                                    }
                                    /*email*/
                                    (new BfwPoints)->updatePoints($get_referral_invite_two_level, $two_referal_points); //добавляем баллы инвайту
                                }
                            } else {

                                (new BfwHistory)->add_history($get_referral_invite_two_level, '+', $referal_two_point_new, '0', $pricinaref);
                                /*email*/
                                $val = get_option('bonus_option_name');
                                if (!empty($val['email-when-order-change'])) {
                                    (new BfwEmail)->getMail($get_referral_invite_two_level, '', $title_email, $message_email);
                                }
                                /*начислить баллы инвайту*/
                                (new BfwPoints)->updatePoints($get_referral_invite_two_level, $two_referal_points); //добавляем баллы инвайту

                            }
                        }
                    }
                }
                //тут будем начислять от инвайта второго уровня
        }
       }
    }
    }

}

/*------------Действие когда оформлен возврат- возврат баллов-----------*/
$order_status_refunded = $val['refunded_points_order_status'] ?? 'refunded';
add_action('woocommerce_order_status_'.$order_status_refunded, 'refunded_computy_points', 10, 1);
function refunded_computy_points($order_id): void
{
    $order = wc_get_order($order_id);

    /*узнаем id покупателя*/
    $customer_user = $order->get_customer_id();
    /*узнаем баллы клиента*/
    $computy_point_old = (new BfwPoints)->getPoints($customer_user);


    $fee_total=0;
    $val = get_option( 'bonus_option_name' );

    if (!empty($val['fee-or-coupon'])) {
        /* если бонусы с помощью купонов  */
        foreach( $order->get_coupon_codes() as $coupon_code  ) {
            $coupon = new WC_Coupon($coupon_code);
            $get_code = $coupon->get_code();
            $cart_discount =  mb_strtolower($val['bonus-points-on-cart']);
            if(strtolower($get_code)=== strtolower($cart_discount)){
                $fee_total = $order->get_discount_total();
            }
        }

    }else{
        /* если бонусы с помощью комиссий  */
    foreach( $order->get_items('fee') as $item_id => $item_fee ) {
        // The fee name
        if ($item_fee->get_name() == $val['bonus-points-on-cart']) {
            $fee_total = $item_fee->get_total();
        }
    }



    }
    if($fee_total<0){
        $fee_total =  absint($fee_total);/*модуль*/
    }
    $cout_point = $computy_point_old+$fee_total;

    /*запись в историю*/
    $pricina = __('Refund of bonus points', 'bonus-for-woo');

    global $wpdb;
    $getplusball = $wpdb->get_var('SELECT points FROM ' . $wpdb->prefix . 'bfw_history_computy WHERE user = "' . $customer_user . '" AND symbol="+" AND orderz = "' .$order_id . '" ');
    $info_email = '';
    if(!empty($getplusball)){
        $getplusball = (new BfwPoints())->roundPoints($getplusball);
    }else{
        $getplusball=0;
    }

    if($getplusball>0){
       /*убираем заработанные баллы*/
        (new BfwHistory)->add_history($customer_user,'-',$getplusball,$order_id,$pricina);
       $cout_point = $cout_point-$getplusball;
        $info_email .= sprintf(__(' The %s bonus points you earned for order no. %s have been canceled.', 'bonus-for-woo'), $getplusball,$order_id);
   }

   if($fee_total>0){
       /*Добавляем списанные баллы*/
       (new BfwHistory)->add_history($customer_user,'+',$fee_total,$order_id,$pricina);
       $info_email .= sprintf(__(' You have returned %s bonus points for order number %s.', 'bonus-for-woo'), $fee_total,$order_id);
   }
    (new BfwPoints)->updatePoints($customer_user,$cout_point);//Обновляем баллы клиенту
    (new BfwRoles)->updateRole($customer_user); //Обновляем роль клиенту
    /*email*/
    $val = get_option( 'bonus_option_name' );



    /*Шаблонизатор письма*/
    $title_email = $val['email-when-order-change-title-vozvrat'] ?? __('Refund of bonus points', 'bonus-for-woo');
    $text_email = $val['email-when-order-change-text-vozvrat'] ?? '';

    $user = get_userdata($customer_user);
    $get_referral = get_user_meta($customer_user, 'bfw_points_referral', true );
    $text_email_array = array('[referral-link]'=> esc_url(site_url().'?bfwkey='. $get_referral),'[user]'=>$user->display_name,'[cashback]'=>$getplusball,'[order]'=>$order_id,'[points]'=>$fee_total,'[total]'=>$cout_point);
    $message_email = (new BfwEmail)->template($text_email,$text_email_array);
    /*Шаблонизатор письма*/

    if(!empty($val['email-when-order-change'])){
          if($getplusball>0 OR $fee_total>0){
                (new BfwEmail)->getMail($customer_user, '', $title_email, $message_email);
            }
        }
    /*email*/

}